#include "SATclassification.h"

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>


// NOTE: coeffs is the array of numFeat coefficients.  coeffs[numFeat] is the constant term.

SATclassification::SATclassification(double* coeffs, int numFeat, double *cMean, double *cStd) {
   numFeatures = numFeat;
   linear = coeffs;
   mean = cMean;
   std = cStd;
}

double SATclassification::estimateClass(double *features) {
   double newFeatures[numFeatures];
   double val; 
   double maxCut, minCut;
   double a=0;
   for (int i=0; i<numFeatures; i++){
     newFeatures[i]= (features[i]-mean[i])/std[i];
     a=a+newFeatures[i]*linear[i];
   }

   maxCut = log(DBL_MAX) -log(2);
   minCut = -log(DBL_MAX);
   if (a > maxCut) a=maxCut;
   if (a < minCut) a=minCut; 
   val = exp(a)/(exp(a)+1);

   return val;
}
